<?php

namespace IMATHUZH\Qfq\Core\Renderer\FormElement;

use IMATHUZH\Qfq\Core\Form\FormElement\AbstractFormElement;
use IMATHUZH\Qfq\Core\Helper\HelperFormElement;
use IMATHUZH\Qfq\Core\Helper\Support;
use IMATHUZH\Qfq\Core\Renderer\Element\ElementRenderer;

abstract class FormElementRenderer
{
    public abstract function renderFormElement(AbstractFormElement $fe, string $renderMode = RENDER_MODE_HTML) : string;

    /**
     * Renders a link to edit the given FormElement
     * @param AbstractFormElement $fe
     * @return string
     * @throws \CodeException
     */
    protected function renderFormEditorUrl(AbstractFormElement $fe) : string {
        // TODO: Multi Form
        //if (!$flagMulti) {
        // Build 'FormElement' Edit symbol. MultiForms: Edit symbol is in thead.
        $titleAttr = Support::doAttribute('title', $fe->formEditorTooltip);
        $icon = Support::wrapTag('<span class="' . GLYPH_ICON . ' ' . GLYPH_ICON_EDIT . '">', '');
        return Support::wrapTag("<a class='hidden " . CLASS_FORM_ELEMENT_EDIT . "' href='". $fe->formEditorUrl ."' $titleAttr>", $icon);
        //}
    }
}